package blatt4;


import java.io.IOException;

/**
 * Clientprogramm, das die Daten des Servers verarbeitet. Diese Klasse darf
 * nicht veraendert werden.
 */
public final class DataReceiver implements Runnable {

    private IClient c;

    /**
     * Konstruktor
     * 
     * @param id
     *            Id des Clients
     * @param server
     *            Adresse des Servers
     * @param port
     *            Port des Servers
     * @throws IOException
     */
    public DataReceiver(String id, String server, int port) throws IOException {
        c = new Client(id);
        c.connect(server, port);
    }

    /**
     * Wartet auf und liest die Nachrichten vom Server. Bei Beendigung der
     * Verbindung durch den Server wird die Methode ebenfalls beendet.
     */
    public void run() {
        int x = 0;
        while (c.isConnected()) {
            try {
                String message = c.receiveMessage();
                if (message == null) {
                    c.disconnect();
                } else {
                    System.out.println("Message received at " + c.getID()
                            + ": " + message);
                    c.sendMessage(message+" ACK");
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
            x++;
        }
        System.out.println("Disconnected");
    }
}